//业务应用中心路由表
import layout from "@/layout/index" //layout直接引用 其他使用路由懒加载
export const businessCenter = [
  {
    path: "/lps/businessCenter",
    component: layout,
    name: "lps/businessCenter",
    meta: {
      title: "业务应用中心",
      icon: "icon_ywyy",
      iconH: "ywyyCenter"
    },
    children: [
      {
        path: "/lps/businessCenter/xfcrt",
        name: "lps/businessCenter/xfcrt",
        component: () => import("@/views/lps/businessCenter/xfcrt"),
        meta: {
          title: "消防CRT",
          icon: "icon_ywyy"
        }
      },
      {
        path: "/lps/businessCenter/afjk",
        name: "lps/businessCenter/afjk",
        component: () => import("@/views/lps/businessCenter/afjk"),
        meta: {
          title: "安防监控",
          icon: "icon_ywyy"
        }
      },
      {
        path: "/lps/businessCenter/xfjk",
        name: "lps/businessCenter/xfjk",
        component: () => import("@/views/lps/businessCenter/xfjk"),
        meta: {
          title: "消防监控",
          icon: "icon_ywyy"
        }
      },
      {
        path: "/lps/clgl",
        name: "lps/clgl",
        meta: {
          title: "车辆管理",
          icon: "icon_xtgl"
        },
        children: [
          {
            path: "/lps/clgl/cljk",
            name: "lps/clgl/cljk",
            component: () => import("@/views/lps/clgl/cljk"),
            meta: {
              title: "车辆监控",
              icon: "icon_xtgl"
            }
          },
          {
            path: "/lps/clgl/jtgl",
            name: "lps/clgl/jtgl",
            component: () => import("@/views/lps/clgl/jtgl"),
            meta: {
              title: "交通管理",
              icon: "icon_xtgl"
            }
          }
        ]
      },
      {
        path: "/lps/sjgl",
        name: "lps/sjgl",
        meta: {
          title: "事件管理",
          icon: "icon_xtgl"
        },
        children: [
          {
            path: "/lps/sjgl/tfsj",
            name: "lps/sjgl/tfsj",
            component: () => import("@/views/lps/sjgl/tfsj"),
            meta: {
              title: "突发类事件",
              icon: "icon_xtgl"
            }
          },
          {
            path: "/lps/sjgl/glsj",
            name: "lps/sjgl/glsj",
            component: () => import("@/views/lps/sjgl/glsj"),
            meta: {
              title: "管理类事件",
              icon: "icon_xtgl"
            }
          }
        ]
      },
      {
        path: "/lps",
        name: "lps",
        meta: {
          title: "设备管理",
          icon: "icon_xtgl",
          iconH: "ytglCenter"
        },
        children: [
          {
            path: "/lps/bkq/index",
            name: "lps/bkq/index",
            component: () => import("@/views/lps/bkq/index.vue"),
            meta: {
              title: "布控球管理",
              icon: "icon_ywyy"
            }
          },
          {
            path: "/lps/yjsb/index",
            name: "lps/yjsb/index",
            component: () => import("@/views/lps/yjsb/index.vue"),
            meta: {
              title: "预警设备管理",
              icon: "icon_ywyy"
            }
          },
          {
            path: "/lps/aqsbss/index",
            name: "lps/aqsbss/index",
            meta: {
              title: "安全设备设施",
              icon: "icon_ywyy"
            },
            component: () => import("@/views/lps/aqsbss/index.vue")
          }
        ]
      }
    ]
  }
]
